import unittest
from Processing import process_main

class ProcessingTest(unittest.TestCase):
     def testCycle(self):
         nodes, edges = process_main(['doiz1'],1,1,True)
         self.assertCountEqual(nodes, ['doiz1', 'doiz2'])
         self.assertCountEqual(edges, [['doiz1', 'doiz2'], ['doiz2', 'doiz1']])

         nodes, edges = process_main(['doiz1'],2,2,True)
         self.assertCountEqual(nodes, ['doiz1', 'doiz2'])
         self.assertCountEqual(edges, [['doiz2', 'doiz1'], ['doiz1', 'doiz2']])

    #def testBigCycle(self):

    #def testEmptyHeight(self):

    #def testEmptyDepth(self):

     def testEmptyDepthHeight(self):
         nodes, edges = process_main(['doi1'],0,0,True)
         self.assertCountEqual(nodes,['doi1'])
         self.assertCountEqual(edges, [])

         nodes, edges = process_main(['doi1', 'doi2'],0,0,True)
         self.assertCountEqual(nodes, ['doi1','doi2'])
         self.assertCountEqual(edges, [['doi1', 'doi2']])

         nodes, edges = process_main(['doi1', 'doi2', 'doi3'],0,0,True)
         self.assertCountEqual(nodes, ['doi1','doi2', 'doi3'])
         self.assertCountEqual(edges, [['doi3', 'doi1'], ['doi1', 'doi2']])


     def testInnerEdges(self):
        nodes, edges = process_main(['doi_ie1'],1,1,True)
        self.assertCountEqual(nodes,['doi_ie1','doi_ie2','doi_ie3'])
        self.assertCountEqual(edges,[['doi_ie1','doi_ie2'],['doi_ie3','doi_ie1'],['doi_ie3','doi_ie2']])
     
     def testRightHeight(self):
          nodes, edges = process_main(['doi_h01'],1,0,True)
          self.assertCountEqual(nodes,['doi_h01'])
          self.assertCountEqual(edges, [])

          nodes, edges = process_main(['doi_h02'],1,0,True)
          self.assertCountEqual(nodes,['doi_h02','doi_h1'])
          self.assertCountEqual(edges, [['doi_h1','doi_h02']])

          nodes, edges = process_main(['doi_h02'],2,0,True)
          self.assertCountEqual(nodes,['doi_h02','doi_h1','doi_h2'])
          self.assertCountEqual(edges, [['doi_h1','doi_h02'], ['doi_h2','doi_h1']])

     def testRightDepth(self):
          nodes, edges = process_main(['doi_d01'],0,1,True)
          self.assertCountEqual(nodes,['doi_d01'])
          self.assertCountEqual(edges, [])

          nodes, edges = process_main(['doi_d02'],0,1,True)
          self.assertCountEqual(nodes,['doi_d02','doi_d1'])
          self.assertCountEqual(edges, [['doi_d02','doi_d1']])

          nodes, edges = process_main(['doi_d02'],0,2,True)
          self.assertCountEqual(nodes,['doi_d02','doi_d1','doi_d2'])
          self.assertCountEqual(edges, [['doi_d02','doi_d1'], ['doi_d1','doi_d2']])

if __name__ == "__main__":
    unittest.main()