# -*- coding: utf-8 -*-
"""
Functions to read old json files to recreate old graph structure

"""

__authors__ = "Donna Löding, Alina Molkentin, Xinyi Tang, Judith Große, Malte Schokolowski"
__email__ = "cis-project2021@zbh.uni-hamburg.de"
__status__ = "Production"
#__copyright__ = ""
#__credits__ = ["", "", "", ""]
#__license__ = ""
#__version__ = ""
#__maintainer__ = ""

  
import json
#sys.path.insert(1, 'C:\Users\Malte\Git\CiS-Projekt\ci-s-projekt-verarbeitung\input')
from input.interface import InputInterface as Input
#import input


class Publication:
    #def __init__(self, doi_url, title, contributors, journal, publication_date, references, citations, group):
    def __init__(self, doi_url, title, contributors, journal, publication_date, group):
        self.doi_url = doi_url
        self.title = title
        self.contributors = contributors
        self.journal = journal
        self.publication_date = publication_date
        self.references = []
        self.citations = []
        self.group = group


class Citation:
    def __init__(self,doi_url, title, contributors, journal, publication_date):
        self.doi_url = doi_url
        self.title = title
        self.contributors = contributors
        self.journal = journal
        self.publication_date = publication_date

class Reference:
    def __init__(self,doi_url, title, contributors, journal, publication_date):
        self.doi_url = doi_url
        self.title = title
        self.contributors = contributors
        self.journal = journal
        self.publication_date = publication_date


def create_pubs_from_json(input_dict):
    '''
    :param input_dict: dictionary read from old graph Json File
    :type json_file: dictionary
    '''
    
    #iterates over the list of nodes
    for node in input_dict["nodes"]:         
        #creates for the nodes the objects class Publication
        
        pub = Publication(node["doi"], node["name"], node["author"], node["journal"], node["year"], node["group"])
        #appends the objects to a list
        list_of_nodes_py.append(pub) 

def add_ref_and_cit_to_pubs(input_dict):
    '''
    :param input_dict: dictionary read from old graph Json File
    :type json_file: dictionary
    '''

    # iterates over the list of edges
    for edge in input_dict["links"]:
        for node in list_of_nodes_py:

            # adds reference to current node
            if (node.doi_url == edge["source"]):
                new_reference = Reference(node.doi_url, node.title, node.contributors, node.journal, node.publication_date)
                node.references.append(new_reference)
            
            # adds citation to current node
            if (node.doi_url == edge["target"]):
                new_citation = Citation(node.doi_url, node.title, node.contributors, node.journal, node.publication_date)
                node.citations.append(new_citation)
        
        # adds edge to list
        list_of_edges_py.append([edge["source"],edge["target"]])


def input_from_json(json_file):
    '''
    :param json_file: Json-Datei for the old graph
    :type json_file: Json File
    '''

    # creates global sets for nodes and edges
    global list_of_nodes_py, list_of_edges_py
    list_of_nodes_py = []
    list_of_edges_py = []

    #opens the json file and saves content in dictionary
    with open(json_file,'r') as file: 
        input_dict = json.load(file)

    # creates nodes of Class Publication from input Json file
    create_pubs_from_json(input_dict)

    # adds references and citations to publications and creates edges 
    add_ref_and_cit_to_pubs(input_dict)
              

    return(list_of_nodes_py, list_of_edges_py)
